<?php
/* $Id: CheckUserFunctions.inc.php 4088 2010-10-28 10:35:06Z denis $ */

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -3 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
@include_once ($NETCAT_FOLDER."vars.inc.php");

/**
  * Получение языков доступных в системе
  * @return array Element[English.php] = English 
  */
function Language_Show() {
  global $ADMIN_FOLDER;
  if ( ($handle = opendir($ADMIN_FOLDER."lang"))) {
    $lang=array();
    while (false !== ($file = readdir($handle))) {
      if (strlen($file)>4 && !strpos($file, '_')) {
        $name=explode(".", $file);
        $lang[$file]=$name[0];
      }
    }
    closedir($handle);
    return($lang);
  } else {
    return(false);
  }
}


function  Unauthorize () {
  global $HTTP_HOST, $EDIT_DOMAIN, $AUTHORIZATION_TYPE;
  global $PHP_AUTH_USER, $PHP_AUTH_PW, $_SERVER, $PHP_AUTH_LANG, $PHP_AUTH_SID;
  global $PHPSESSID, $MODULE_VARS;
  global $db;
  
  if ( $sname = session_name() ) global $$sname;
    
  switch (true) {
    // cookie
    case $AUTHORIZATION_TYPE=='cookie':
      $EditDomainHost = substr($EDIT_DOMAIN,0,nc_strlen($EDIT_DOMAIN)-nc_strlen(strchr($EDIT_DOMAIN,"/")));
      $db->query("DELETE FROM `Session` WHERE `Session_ID` = '".$PHP_AUTH_SID."' OR `SessionTime` < '".time()."'");
      // unset back-end and front-end cookies
      $cookie_domain = $HTTP_HOST;
      setcookie ("PHP_AUTH_SID", NULL, NULL, "/", $cookie_domain);
      setcookie ("PHP_AUTH_LANG", NULL, NULL, "/", $cookie_domain);
      $cookie_domain = str_replace("www.", "", $HTTP_HOST);
      setcookie ("PHP_AUTH_SID", NULL, NULL, "/", $cookie_domain);
      setcookie ("PHP_AUTH_LANG", NULL, NULL, "/", $cookie_domain);
    break;
    // http
    case $AUTHORIZATION_TYPE=='http':
      unset($_SERVER['PHP_AUTH_USER']);
      unset($_SERVER['PHP_AUTH_PW']);
      unset($_SERVER['HTTP_AUTHORIZATION']);
    break;
    // session
    case $AUTHORIZATION_TYPE=='session':
      if ($$sname != "")
      {
        $db->query("DELETE FROM Session WHERE Session_ID = '".$$sname."' OR SessionTime < ".time());
          $$sname = $_POST['$sname'];
          $$sname = $_GET['$sname'];
      }
      session_start();
      unset($_SESSION['User']);
      session_destroy();
    break;
  }
}

function LoginFormHeader () {
  global $ADMIN_FOLDER;
  $nc_core = nc_Core::get_object();
  $lang = $nc_core->lang->detect_lang();
  require_once($ADMIN_FOLDER."lang/".$lang.".php");
  echo "<!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.01 Transitional'>
<html>
  <head>
  <meta http-equiv='content-type' content='text/html; charset=".$nc_core->NC_CHARSET."'/>
  <style type='text/css'>
    body {
      margin:0px;
      padding:0px;
      background:#FFF;
      font-size:70%;
      font-family:verdana;
      overflow:hidden;
      height:100%;
    }
    a {
      color:#FFF;
    }
    a.relogin {
      color:#3C7EA4;
    }
    div.top_line, div.bottom_line { 
      padding:10px;
      color:#FFF;
      background:#3C7EA4;
      text-align:center;
      font-weight:bold;
    }
    div.bottom_line {
      position:absolute;
      width:100%;
      padding:0;
    }
    div.bottom_line div {
      margin:10px;
    }
    div.top_line {
      top:0;
    }
    div.bottom_line {
      bottom:0;
    }
    table {
      font-size:100%
    }
    td {
      text-align:left;
    }
  </style>
  <title>NetCat</title>
  </head>
  <body>
    <div class='top_line'>
      ".CONTROL_AUTH_HTML_CMS." <a href=\"http://www.netcat.ru\">NetCat</a>
    </div>
    <div style='overflow:hidden;position:absolute; top:40%; width:100%' align='center'>
  ";
}

function LoginFormFooter () {
  ?>
    </div>
    <div class='bottom_line'>
      <div>&copy; 1999&#8212;<?=date("Y")?> <a href='http://www.netcat.ru'><?=ENDHTML_NETCAT?></a></div>
    </div>
  </body>
</html>
  <?php
}


/**
  * Вывод формы авторизации пользователя
  */
function LoginForm () {
  global $REQUEST_URI, $AUTH_USER, $ADMIN_LANGUAGE, $ADMIN_TEMPLATE;
  global $posting, $USER_LANG, $ADMIN_AUTHTYPE, $AUTHORIZATION_TYPE;

  ?>
  <script type='text/javascript'>
    function authCheckFields () {
      var authForm = document.getElementById('AUTH_FORM');
      var login = document.getElementById('AUTH_USER');
      var pass = document.getElementById('AUTH_PW');
      
      switch (true) {
        case (login.value == '' && pass.value == ''):
          alert('<?=CONTROL_AUTH_FIELDS_NOT_EMPTY?>');
        break;
        case (login.value == ''):
          alert('<?=CONTROL_AUTH_LOGIN_NOT_EMPTY?>');
        break;
        default:
          authForm.submit();
      }
    }
  </script>
  <form action='<?=$REQUEST_URI?>' method='post' name='AUTH_FORM' id='AUTH_FORM'>
	<input type='hidden' name='AuthPhase' value='1'>
	<table border='0' cellpadding='4' cellspacing='0'>
  <tr>
	<td><?=CONTROL_AUTH_HTML_LOGIN?></td>
	<td><input type='text' name='AUTH_USER' id='AUTH_USER' size='32' maxlength='255' value='<?=htmlspecialchars( stripcslashes($AUTH_USER) )?>'></td>
	</tr>
	<tr>
	<td><?=CONTROL_AUTH_HTML_PASSWORD?></td>
	<td><input type='password' name='AUTH_PW' id='AUTH_PW' size='32' maxlength='32'></td>
	</tr>
	<tr>
	<td><?=CONTROL_AUTH_HTML_LANG?></td>
	<td>
	<select name='NEW_AUTH_LANG' style='width:100%'>
  <?php
  global $nc_personal;
  $lang = $nc_personal ? array('Russian.php' => 'Russian') : Language_Show();


  $sellang = $_COOKIE['PHP_AUTH_LANG'] ? $_COOKIE['PHP_AUTH_LANG'] : $ADMIN_LANGUAGE;

  foreach($lang AS $val) {
    echo "<option value='".$val."'".($val==$sellang ? " selected" : "").">".$val."</option>\n";
  }
  
  ?>
  </select>
  </td>
	</tr>
  
  <tr>
		<?=($ADMIN_AUTHTYPE == 'manual' && $AUTHORIZATION_TYPE == 'cookie' ? "<td rowspan='2'>" : "<td>")?>
    <?php
      if ( !($_REQUEST['AUTH_USER'] || $_REQUEST['AUTH_PW']) ) {
        echo "<img src='".$ADMIN_TEMPLATE."img/i_netcat_big.gif' width='32' height='32' alt='NetCat' title='NetCat'/>";
      }
      else {
        echo "<img src='".$ADMIN_TEMPLATE."img/status_error.gif' width='32' height='32' alt='".CONTROL_AUTH_LOGIN_OR_PASSWORD_INCORRECT."' title='".CONTROL_AUTH_LOGIN_OR_PASSWORD_INCORRECT."'/>";
      }
    ?>
    </td>
  <?php
  if ($ADMIN_AUTHTYPE == 'manual' && $AUTHORIZATION_TYPE == 'cookie') {
		echo "<td><label><input type='checkbox' name='loginsave'/>&nbsp;".CONTROL_AUTH_HTML_SAVELOGIN."</label></td>".
      "</tr>".
      "<tr>";
  }
  ?>
	<td>
	<input type='submit' value='<?=CONTROL_AUTH_HTML_AUTH?>' onclick='authCheckFields(); return false;'>
  <?php
  
  if ($posting && $REQUEST_URI!=$REQUESTED_FROM) {
    echo "<br/><a href='".$REQUESTED_FROM."' class='relogin'>".CONTROL_AUTH_HTML_BACK."</a>";
  }

  ?>
  </td>
	</tr>
  </table>
	</form>
	
	<script type='text/javascript'>
    var authForm = document.getElementById('AUTH_FORM');
    // перенаправлять туда, куда пользователь хотел зайти
    authForm.action += window.location.hash;
  </script>
  <?php
}

function Refuse () {
  global $AUTH_TYPE, $admin_mode;
 // AJAX call
  if ( $_POST["NC_HTTP_REQUEST"] || NC_ADMIN_ASK_PASSWORD===false) {
    // issue strange header (actually not RFC2616-compliant) and die
    header($_SERVER['SERVER_PROTOCOL']." 401 Authorization Required");
    exit;
  }

  switch ($AUTH_TYPE) {
    case 'cookie':
    case 'session':
      if (!$admin_mode) {
        UserLoginForm ();
      }
      else {
        LoginFormHeader();
        LoginForm ();
        LoginFormFooter();
      }
      break;

    default :
      # по дефолту авторизация 'http'
      Header ("WWW-authenticate:  basic  realm=Enter your login and password");
      Header ($_SERVER['SERVER_PROTOCOL'].' 401  Unauthorized');
      LoginFormHeader();
      print CONTROL_AUTH_MSG_MUSTAUTH;
      LoginFormFooter();
  }
  
  exit;
}




/**
 * Функция дял авторизации
 *
 * @param int $required_id = 0, если не равен 0, то выполнится авторизация пользователя с id  = required_id
 * @param str фаза авторизации: attempt - попытка продлить авторизацию, authorize - авторизация
 * @param unknown_type $open_id
 * @param str варианта автризации: 'normal', 'hash'
 * @param bool - автризация в админку
 * @param bool создавать сессию
 * 
 * @return int  идентификатор авторизированного пользователя
 */
function Authorize ($required_id = 0, $auth_phase = 'attempt', $open_id = '', $auth_variant='normal', $isInsideAdmin = 0, $create_session = 1) {
	$sname = session_name();
	global $PHP_AUTH_USER, $PHP_AUTH_PW, $PHP_AUTH_LANG,$PHP_AUTH_SID;
	global $AUTH_USER_ID, $AUTH_USER_GROUP;
	global $AUTH_USER, $AUTH_PW, $AUTH_LANG;
	global $AUTHORIZATION_TYPE;
	global $EDIT_DOMAIN, $AUTH_TYPE, $HTTP_HOST, $MODULE_FOLDER;
	global $db, $SUB_FOLDER;
	global $perm, $AuthPhase, $admin_mode;
	global $AUTHORIZE_BY;
	global $$sname, $ADMIN_AUTHTIME, $ADMIN_AUTHTYPE;
	global $nc_personal, $nc_core;
	
	if ( is_object($perm) ) return $AUTH_USER_ID;

  $MODULE_VARS = $nc_core->modules->get_module_vars();
  $user_result = 0;
  
	$AUTH_TYPE = $AUTHORIZATION_TYPE;    
	$AUTH_USER_ID = 0;
	$AUTH_USER_GROUP = 0; 

	$required_id += 0;
	
	// AuthPhash может быть глобальной
	if ( $AuthPhase ) $auth_phase = 'authorize';
  // вариант авторизации
	if ( $auth_phase == 'authorize') {
	 if ( !$auth_variant || !in_array($auth_variant, array('normal', 'hash', 'open_id'))) $auth_variant = 'normal';
	}

	// SESSION предварительная проверка
	if ($AUTH_TYPE == 'session') {
		if ($$sname) {
			$_GET[session_name()]  = $$sname;
      $_POST[session_name()] = $$sname;
		}
		else {
			$session_id = md5(uniqid(rand(), 1));
      session_id($session_id);
		}
		
		session_start();
    
		if ($_SESSION['User']['IsLogin'] == "1") {
			if ($_SESSION['User']['IP'] != getenv("REMOTE_ADDR")) header ("Location: ".$SUB_FOLDER."/");
			if ((time()-$_SESSION['User']['datetime']) > ini_get('session.gc_maxlifetime')) unset($_SESSION['User']);
		}
    
		$_SESSION['User']['datetime'] = time();
		$PHP_AUTH_USER = $_SESSION['User']['PHP_AUTH_USER'];
		$PHP_AUTH_PW   = $_SESSION['User']['PHP_AUTH_PW'];
		//$PHP_AUTH_LANG = $_SESSION['User']['PHP_AUTH_LANG'];
	}

	
	// Авторизация (проверка) || HTTP валидация
	if ( $auth_phase == 'authorize' || $AUTH_TYPE == 'http') {
		if ($AUTH_TYPE != 'http') {
			$PHP_AUTH_USER = $AUTH_USER;
			$PHP_AUTH_PW   = $AUTH_PW;
			//$PHP_AUTH_LANG = $AUTH_LANG;
		}
		if ( $open_id  && $nc_core->modules->get_by_keyword('auth') && nc_auth_openid_possibility() ) {
		  $user_result = $db->get_results("SELECT `User`.User_ID AS `User_ID`, `Password`, 
        ug.`PermissionGroup_ID` AS PermissionGroups_ID, 
        `User`.PermissionGroup_ID, `Language`, `User`.`".$AUTHORIZE_BY."`, `InsideAdminAccess`, `Catalogue_ID`
        FROM `User`, `User_Group` as ug, `User_OpenID`
        WHERE `User_OpenID`.`User_ID`=`User`.`User_ID`
        AND `User_OpenID`.`OpenID`='".$db->escape($open_id)."' 
        AND `Checked` = 1 
        AND `User`.User_ID = ug.`User_ID`
        ORDER BY ug.ID", ARRAY_A);
		}
		else {
		  $user_result = $db->get_results("SELECT `User`.User_ID AS `User_ID`, `Password`, 
        ug.`PermissionGroup_ID` AS PermissionGroups_ID, 
        `User`.PermissionGroup_ID, `Language`, `User`.`".$AUTHORIZE_BY."`, `InsideAdminAccess`, `Catalogue_ID`
        FROM `User`, `User_Group` as ug
        WHERE 
        ".( $required_id ? " `User`.`User_ID` = '".$required_id."'" : "
        `User`.`".$AUTHORIZE_BY."` = '".$PHP_AUTH_USER."' 
        AND `Password` = ".$nc_core->MYSQL_ENCRYPT."('".$PHP_AUTH_PW."')
        " )."
        AND `Checked` = 1 
        AND `User`.User_ID = ug.`User_ID`
        ORDER BY ug.ID", ARRAY_A);
		} 
	
	
	} // SESSION валидация
	else {
    $_session_id = ( $AUTH_TYPE=='session' ? $$sname : ($AUTH_TYPE=='cookie' ? $PHP_AUTH_SID : "") );
    if ($_session_id) {
      $user_result = $db->get_results("SELECT g.`PermissionGroup_ID` AS PermissionGroups_ID,
                                              u.`User_ID`, u.`Password`, u.`PermissionGroup_ID`, u.`Language`, 
                                              u.`".$AUTHORIZE_BY."`,u.`InsideAdminAccess`, u.`Catalogue_ID`,
                                              s.`LoginSave`,  s.`AuthVariant`
        FROM (`User` AS u, `User_Group` as g) 
        RIGHT JOIN `Session` AS s ON u.`User_ID` = s.`User_ID`
        WHERE u.`Checked` = 1 
        AND u.`User_ID` != 0 
        AND u.`User_ID` = g.`User_ID`
        AND s.`Session_ID` = '".$_session_id."' 
        AND s.`SessionTime` > '".time()."'", ARRAY_A);
    }
  }
	
  // на случай, есил поля не существует
  if ( strstr($db->last_error, 'AuthVariant') ) {
    $db->query("ALTER TABLE `Session` ADD `AuthVariant` ENUM ('normal', 'hash', 'open_id') DEFAULT 'normal';");
    return Authorize($required_id, $auth_phase, $open_id, $auth_variant, $isInsideAdmin, $create_session);
  }
 
  if ( $user_result[0]['AuthVariant'] == 'hash') {
    // искуственная ситуация: пользователь авторизовался по хэшу без модуля
    if ( !$nc_core->modules->get_by_keyword('auth') )  return 0;
    // нужна проверка на возможность авторизоваться в разделе/админке
    require_once( $MODULE_FOLDER.'auth/function.inc.php');
    $nc_auth = nc_auth::get_object(); 
    if ( !$nc_auth->hash->check( $isInsideAdmin, 0) ) {
      unset($user_result); // проверка не прошла
    }
  }
  
	if (!$user_result) {
		if ($admin_mode || $AUTH_TYPE == "http") {
			Refuse();
		}
		else {
			return false;
		}
	}
  
	$result = $user_result[0];
	$UserID            = $result['User_ID'];
	$Password          = $result['Password'];
	$UserGroup         = $result['PermissionGroup_ID'];
	$Language          = $result['Language'];
	$PHP_AUTH_USER     = $result[$AUTHORIZE_BY];
	$LoginSave         = ($result['LoginSave'] || $ADMIN_AUTHTYPE == 'always' ? 1 : 0);
	$InsideAdminAccess = $result['InsideAdminAccess'];
	$Catalogue_ID      = $result['Catalogue_ID'];

  // трансляция события
	if ( $auth_phase == 'authorize' ) {
    $nc_core->event->execute("authorizeUser", $UserID);
  }
  
	// для прямой совместимости
	if ($AUTH_TYPE != 'http') $PHP_AUTH_PW = $Password;
	if ($Language) $AUTH_LANG = /*$PHP_AUTH_LANG = */$Language;
	
	
	if ($AUTH_TYPE != 'http') {
		$SessionStart = time();
		$SessionTime = ($ADMIN_AUTHTIME ? $SessionStart + $ADMIN_AUTHTIME : $SessionStart + 24 * 3600);
		$UserIP = sprintf("%u", ip2long($_SERVER['REMOTE_ADDR']));
	}
	
	
	// создание / обновление сессии
	if ( $create_session ) {
    switch (true) {
      // SESSION авторизация/валидация
    	case $AUTH_TYPE == 'session':
    		if ( $auth_phase == 'authorize' ) {
    			$OldSid = ($$sname ? $$sname : session_id());
    			$db->query("DELETE FROM `Session` WHERE `SessionTime` < '".$SessionStart."'".($OldSid ? " OR `Session_ID` = '".$OldSid."'" : "") );
    			
    			$db->query("INSERT INTO `Session` (`Session_ID`, `User_ID`, `SessionStart`, `SessionTime`, `UserIP`, `LoginSave`, `Catalogue_ID`, `AuthVariant`)
            VALUES ('".$$sname."', '".$UserID."', '".$SessionStart."', '".$SessionTime."', '".$UserIP."', '".$LoginSave."', '".$Catalogue_ID."', '".$auth_variant."')");
    		}
    		else {
    			$db->query("UPDATE `Session` SET `SessionTime` = '".$SessionTime."' WHERE `Session_ID` = '".$$sname."'");
    		}
    		
    		$_SESSION['User']['ID']            = $UserID;
    		$_SESSION['User']['PHP_AUTH_USER'] = $PHP_AUTH_USER;
    		$_SESSION['User']['PHP_AUTH_PW']   = $Password;
    		$_SESSION['User']['PHP_AUTH_LANG'] = $PHP_AUTH_LANG;
    		$_SESSION['User']['datetime']      = $SessionStart;
    		$_SESSION['User']['IsLogin']       = "1";
    		$_SESSION['User']['IP']            = $_SERVER['REMOTE_ADDR'];
    	break;  	
    	
      // COOKIE авторизация/валидация
    	case $AUTH_TYPE == 'cookie':
    		if ( $auth_phase == 'authorize' ) {
    			$OldSid = ($PHP_AUTH_SID ? $PHP_AUTH_SID : $$sname);
    			$db->query("DELETE FROM `Session` WHERE `SessionTime` < '".$SessionStart."'".($OldSid ? " OR `Session_ID` = '".$OldSid."'" : ""));
    			$LoginSave = ($_POST['loginsave'] || $ADMIN_AUTHTYPE == "always" ? 1 : 0);
    			
    			$PHP_AUTH_SID = ($$sname ? $$sname : md5(uniqid(rand(), 1)));
    			$result = $db->query("INSERT INTO `Session` (`Session_ID`, `User_ID`, `SessionStart`, `SessionTime`, `UserIP`, `LoginSave`, `Catalogue_ID`, `AuthVariant`)
            VALUES ('".$PHP_AUTH_SID."', '".$UserID."', '".$SessionStart."', '".$SessionTime."', '".$UserIP."', '".$LoginSave."', '".$Catalogue_ID."', '".$auth_variant."')");
    		}
    		// валидация
    		else {
    			$db->query("UPDATE `Session` SET `SessionTime` = '".$SessionTime."', `UserIP` = '".$UserIP."' WHERE `Session_ID` = '".$PHP_AUTH_SID."'");
    		}
    		
    		if (!$LoginSave) $SessionTime = 0;
    		$cookie_domain = ($MODULE_VARS['auth']['COOKIES_WITH_SUBDOMAIN'] && nc_strpos($HTTP_HOST, '.') !== false ? str_replace("www.", "", $HTTP_HOST) : NULL);
    		setcookie('PHP_AUTH_SID',  $PHP_AUTH_SID,  $SessionTime, "/", $cookie_domain);
       
    		setcookie('PHP_AUTH_LANG', $PHP_AUTH_LANG, $SessionTime, "/", $cookie_domain);
    	break;
    	
      // HTTP
    	case $AUTH_TYPE == 'http':
    		end;
    	break;
    	
    	case $admin_mode || $AUTHORIZATION_TYPE == "http":
    		Refuse();
    	break;
      
      default:
        return false;
    }
  
	}

	$AUTH_USER_ID    = $UserID;
	$AUTH_USER_GROUP = $UserGroup;
	
	if ( $nc_personal ) {
	 $perm = new Permission_Personal ();  
	}
	else {
	 $perm = new Permission ($UserID,0, $user_result);
	}

	return ($UserID);
}



function CheckUserRights ($SubClassID, $action, $posting) {
  global $db;
  global $perm;
  # значения action
  #   1 - read
  #   2 - add
  #   4 - change
  #   8 - subscribe
  #  16 - moderate

  if (!$perm) Authorize();
  if (!is_object($perm)) return 0;
 
  if ( $perm->isSupervisor() ) {
      return 1;
  }


  switch ($action) {
    case "read":
      $mask = MASK_READ | MASK_MODERATE; //moderator can read all
      break;
    case "comment":
      $mask = MASK_COMMENT;
      break;
    case "add":
      $mask = MASK_ADD; 
      break;
    case "change":
      global $delete, $checked; // нужно точно узнать, какое изменение происходит  
      $mask =  MASK_MODERATE; // в любом случае модератор может все
      switch (true) {
        case isset($delete):
          $mask |= MASK_DELETE;
          break;
        case isset($checked):
          $mask |= MASK_CHECKED;
          break;
        default:
        $mask |= MASK_EDIT;
      }
      break;
    case "subscribe":
      $mask = MASK_SUBSCRIBE;
      break;
    case "moderate":
      $mask = MASK_MODERATE;
      break;
    default:
      $mask = MASK_READ | MASK_MODERATE;
      break;
  }

  if ( $perm->isGuest() ) { // право гость
    //дает просматривать без записи в БД
    return ($posting == 0 || $mask == 1);
  }


  #сообственно, проверка прав
  //случай, когда в разделе есть компонент
  if ( $SubClassID)
    return $perm->isSubClass ($SubClassID, $mask, true);
  
  // Возможен случай, когда в разделе нет компонента, в этом случае надо проеврить
  // на доступ к разделу.  
  global $current_sub;
  return $perm->isSubdivision($current_sub['Subdivision_ID'], $mask);
   
}



?>
